//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RGrids"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  SortDirection = ssdNone;  
  SortColumn = -1;       

  //  
  TRGridCoord MainCoord, StartCoord, EndCoord;

  MainCoord.X = 0;
  MainCoord.Y = 0;

  StartCoord.X = 0;
  StartCoord.Y = 0;

  EndCoord.X = 0;
  EndCoord.Y = 1;
  
  RGrid1->Holder->CellsUnions->Add(MainCoord, StartCoord, EndCoord);

  MainCoord.X = 1;
  MainCoord.Y = 0;

  StartCoord.X = 1;
  StartCoord.Y = 0;

  EndCoord.X = 6;
  EndCoord.Y = 0;
  
  RGrid1->Holder->CellsUnions->Add(MainCoord, StartCoord, EndCoord);

  MainCoord.X = 1;
  MainCoord.Y = 1;

  StartCoord.X = 1;
  StartCoord.Y = 1;

  EndCoord.X = 2;
  EndCoord.Y = 1;
  
  RGrid1->Holder->CellsUnions->Add(MainCoord, StartCoord, EndCoord);

  MainCoord.X = 3;
  MainCoord.Y = 1;

  StartCoord.X = 3;
  StartCoord.Y = 1;

  EndCoord.X = 4;
  EndCoord.Y = 1;
  
  RGrid1->Holder->CellsUnions->Add(MainCoord, StartCoord, EndCoord);

  MainCoord.X = 5;
  MainCoord.Y = 1;

  StartCoord.X = 5;
  StartCoord.Y = 1;

  EndCoord.X = 6;
  EndCoord.Y = 1;
  
  RGrid1->Holder->CellsUnions->Add(MainCoord, StartCoord, EndCoord);

  //  Data   
  for (int i = 0; i < RGrid1->Holder->ColCount; i++)
  {
    RGrid1->Holder->Cols[i]->Data = new TRowData;
    ((TColData *)RGrid1->Holder->Cols[i]->Data)->ColIndex = i;
  }

  AnsiString ContentFile = ExtractFilePath(Application->ExeName) + "Content.ini";
  if (FileExists(ContentFile))
  {
    TStringList *RowsList = new TStringList();
    RowsList->LoadFromFile(ContentFile);

    if (RowsList->Count > 0)
    {         
      RGrid1->Holder->RowCount = RGrid1->Holder->FixedRows + RowsList->Count;

      //  Data     
      for (int k = 0; k < RGrid1->Holder->RowCount; k++)
      {  
        RGrid1->Holder->Rows[k]->Data = new TRowData;
        ((TRowData *)RGrid1->Holder->Rows[k]->Data)->RowIndex = -1;
        
        for (int i = 0; i < RGrid1->Holder->ColCount; i++)
        {
          RGrid1->Holder->Cells[i][k]->Data = new TCellText;
          ((TCellText *)RGrid1->Holder->Cells[i][k]->Data)->CellText = "";
        }
      }
    
      //    Content.ini
      for (int k = 0; k < RowsList->Count; k++)
      {
        TStringList *CellsList = new TStringList();
        CellsList->Text = StringReplace(RowsList->Strings[k], " ", "\n", TReplaceFlags() << rfReplaceAll); 

        ((TRowData *)RGrid1->Holder->Rows[RGrid1->Holder->FixedRows + k]->Data)->RowIndex = k + 1;

        for (int i = 0; i < CellsList->Count; i++)
        {
          ((TCellText *)RGrid1->Cells[RGrid1->Holder->FixedCols + i][RGrid1->Holder->FixedRows + k]->Data)->CellText = CellsList->Strings[i];
        }

        delete CellsList;
      }  
    }
  }

  UpdateSatusBar(RGrid1->Col, RGrid1->Row);      
}
//---------------------------------------------------------------------------
//    Data 
void __fastcall TForm1::RGrid1FreeCell(TRCustomGrid *Sender, TRCell *Cell)
{
  if (Cell->Data)
  {
    delete (TCellText *)Cell->Data;
    Cell->Data = NULL;
  }
} 
//---------------------------------------------------------------------------
//    Data   
void __fastcall TForm1::RGrid1FreeCellsVector(TRCustomGrid *Sender,
      TRCellsVector *CellsVector)
{
  if (CellsVector->Data)
  {
    if (CellsVector->IsColumn)
    {
      delete (TColData *)CellsVector->Data;
    }
    else
    {
      delete (TRowData *)CellsVector->Data;
    }

    CellsVector->Data = NULL;
  }      
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1DrawCellText(TRCustomGrid *Sender,
      TRCell *Cell, int ACol, int ARow, TRGridDrawStates State,
      TRect &Rect, AnsiString &CellText, bool &Multiline,
      TAlignment &HorAlignment, TRVertAlignment &VertAlignment)
{
  int HCol = Cell->HolderCol;
  int HRow = Cell->HolderRow; 

  if (HRow < RGrid1->Holder->FixedRows)
  {
    if (HRow == 0)
    {
      if (HCol == 0)
      {
        CellText = "";
      }
      else
      { 
        CellText = " ";
      }  
    }
    else if (HRow == 1)
    {
      if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 1)
        || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 2) )
      {
        CellText = " 1";
      }
      else if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 3)
             || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 4))
      {
        CellText = " 2";
      }
      else if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 5)
             || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 6))
      {
        CellText = " 3";
      }
    }
    else if (HRow == 2)
    {
      CellText = IntToStr(((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex);

      if (ACol == RGrid1->Col)
      {
        RGrid1->Canvas->Font->Color = clRed;
      }
    }

    Rect.Left = Rect.Left + 3;
  }
  else
  {
    if (HCol < RGrid1->Holder->FixedCols)
    {
      Rect.Left = Rect.Left + 3;
      CellText = IntToStr(((TRowData *)RGrid1->Holder->Rows[HRow]->Data)->RowIndex);

      if (ARow == RGrid1->Row)
      {
        RGrid1->Canvas->Font->Color = clRed;
      }
      
    }
    else
    {
      if (Cell->Data)
      {
        Rect.Left = Rect.Left + 3;
        CellText = ((TCellText *)Cell->Data)->CellText;
      } 
    }  
  }       
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1DrawImage(TRCustomGrid *Sender, TRCell *Cell,
      int ACol, int ARow, TRGridDrawStates State, TRect &Rect,
      int &ImageIndex, TAlignment &HorAlignment,
      TRVertAlignment &VertAlignment)
{
  int HCol = Cell->HolderCol;
  int HRow = Cell->HolderRow; 

  if (HRow == (RGrid1->Holder->FixedRows - 1))
  {
    if (SortColumn < 0)
    {
      ImageIndex = 2;
    }
    else
    {
      if (SortColumn == HCol)
      {
        if (SortDirection == ssdUp)
        {
          ImageIndex = 0;
        }
        else //if (SortDirection == ssdDn)
        {
          ImageIndex = 1;
        }
      }  
      else
      {
        ImageIndex = 2;
      }
    }  

    HorAlignment = taRightJustify;
  }
  else if (HCol  == 0)
  {
    if (HRow >= (RGrid1->Holder->FixedRows))
    {
      if (HRow == RGrid1->Row)
      {
        ImageIndex = 3;
        HorAlignment = taRightJustify;
      }
    }
  }  
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1CheckButton(TRCustomGrid *Sender,
      TRCell *Cell, int ACol, int ARow, bool &Enabled)
{
  int HCol = Cell->HolderCol;
  int HRow = Cell->HolderRow; 
  
  if ((HCol == 0) && (HRow == 0))
  {
    Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1FixedCellClick(TRCustomGrid *Sender,
      TRCell *Cell, int ACol, int ARow)
{
  int HCol = Cell->HolderCol;
  int HRow = Cell->HolderRow; 

  if (HRow < RGrid1->Holder->FixedRows)
  {
    if (HRow == 0)
    {
      if (HCol != 0)
      {
        RGrid1->Holder->SetVisibleAllCols();
      }
    }
    else if (HRow == 1)
    {
      if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 1)
        || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 2) )
      {
        TList *ColsList = NULL;
        ColsList = new TList();
        ColsList->Clear();

      
        for (int k = 0; k < RGrid1->Holder->FixedCols; k++)
        {
          ColsList->Add(RGrid1->Holder->Cols[k]); 
        }

        for (int k = RGrid1->Holder->FixedCols; k < RGrid1->Holder->ColCount; k++)
        {
          if ( (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 1)
            || (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 2) )
          {
            ColsList->Add(RGrid1->Holder->Cols[k]); 
          }  
        }
        
        RGrid1->Holder->SetVisibleColsRange(ColsList);

        delete ColsList;
      }
      else if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 3)
            || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 4) )
      {
        TList *ColsList = NULL;
        ColsList = new TList();
        ColsList->Clear();

      
        for (int k = 0; k < RGrid1->Holder->FixedCols; k++)
        {
          ColsList->Add(RGrid1->Holder->Cols[k]); 
        }

        for (int k = RGrid1->Holder->FixedCols; k < RGrid1->Holder->ColCount; k++)
        {
          if ( (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 3)
             || (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 4) )
          {
            ColsList->Add(RGrid1->Holder->Cols[k]); 
          }  
        }

        RGrid1->Holder->SetVisibleColsRange(ColsList);

        delete ColsList;
      }
      else if ( (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 5)
             || (((TColData *)RGrid1->Holder->Cols[HCol]->Data)->ColIndex == 6) )
      {
        TList *ColsList = NULL;
        ColsList = new TList();
        ColsList->Clear();

      
        for (int k = 0; k < RGrid1->Holder->FixedCols; k++)
        {
          ColsList->Add(RGrid1->Holder->Cols[k]); 
        }

        for (int k = RGrid1->Holder->FixedCols; k < RGrid1->Holder->ColCount; k++)
        {
          if ( (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 5)
            || (((TColData *)RGrid1->Holder->Cols[k]->Data)->ColIndex == 6) )
          {
            ColsList->Add(RGrid1->Holder->Cols[k]); 
          }  
        }

        RGrid1->Holder->SetVisibleColsRange(ColsList);

        delete ColsList;
      }
    }
    else if (HRow == 2)
    {
      if (SortColumn != HCol)
      {
        int OldSortColumn = SortColumn;

        SortColumn = HCol;
        SortDirection = ssdUp;

        if (OldSortColumn > -1)
        {
          if (RGrid1->Holder->Cols[OldSortColumn]->Visible)
          {
            OldSortColumn = RGrid1->Holder->Cols[OldSortColumn]->GridIndex;
          
            RGrid1->InvalidateCell(OldSortColumn, HRow);
          }  
        }

        RGrid1->Holder->Sort(CompareRowsUp, true);
      }
      else
      {
        if (SortDirection == ssdDn)
        {
          SortDirection = ssdUp;
          RGrid1->Holder->Sort(CompareRowsUp, true);
        }
        else
        {
          SortDirection = ssdDn;
          RGrid1->Holder->Sort(CompareRowsDn, true);
        }
      }
    }  
  }
  else
  {
    if (HCol == 0)
    {
      RGrid1->Row = ARow;  
      RGrid1->Col = ACol + 1;  
    }
  }      
}
//---------------------------------------------------------------------------
int __fastcall CompareRowsUp(void * Item1, void * Item2)
{
  int Result;

  //   
  if (Form1->SortColumn == 0)
  {
    if ( ((TRowData *)((TRCellsVector *)Item1)->Data)->RowIndex <  ((TRowData *)((TRCellsVector *)Item2)->Data)->RowIndex)
    {
      Result = -1;
    }
    else if ( ((TRowData *)((TRCellsVector *)Item1)->Data)->RowIndex >  ((TRowData *)((TRCellsVector *)Item2)->Data)->RowIndex)
    {
      Result = 1;
    }
    else
    {
      Result = 0;
    }
  }
  //    ()
  else
  {
    int HRow1 = ((TRCellsVector *)Item1)->HolderIndex;
    int HRow2 = ((TRCellsVector *)Item2)->HolderIndex;

    if (((TCellText *)((TRCellsVector *)Item1)->Owner->Cells[Form1->SortColumn][HRow1]->Data)->CellText < ((TCellText *)((TRCellsVector *)Item2)->Owner->Cells[Form1->SortColumn][HRow2]->Data)->CellText)
    {
      Result = -1;
    }
    else if (((TCellText *)((TRCellsVector *)Item1)->Owner->Cells[Form1->SortColumn][HRow1]->Data)->CellText > ((TCellText *)((TRCellsVector *)Item2)->Owner->Cells[Form1->SortColumn][HRow2]->Data)->CellText)
    {
      Result = 1;
    }
    else
    {
      Result = 0;
    }
  }
  
  
  return Result;
}
//---------------------------------------------------------------------------
int __fastcall CompareRowsDn(void * Item1, void * Item2)
{
  int Result = 0;

  //   
  if (Form1->SortColumn == 0)
  {
    if ( ((TRowData *)((TRCellsVector *)Item1)->Data)->RowIndex <  ((TRowData *)((TRCellsVector *)Item2)->Data)->RowIndex)
    {
      Result = 1;
    }
    else if ( ((TRowData *)((TRCellsVector *)Item1)->Data)->RowIndex >  ((TRowData *)((TRCellsVector *)Item2)->Data)->RowIndex)
    {
      Result = -1;
    }
    else
    {
      Result = 0;
    }
  }
  //    ()
  else
  {
    int HRow1 = ((TRCellsVector *)Item1)->HolderIndex;
    int HRow2 = ((TRCellsVector *)Item2)->HolderIndex;

    if (((TCellText *)((TRCellsVector *)Item1)->Owner->Cells[Form1->SortColumn][HRow1]->Data)->CellText < ((TCellText *)((TRCellsVector *)Item2)->Owner->Cells[Form1->SortColumn][HRow2]->Data)->CellText)
    {
      Result = 1;
    }
    else if (((TCellText *)((TRCellsVector *)Item1)->Owner->Cells[Form1->SortColumn][HRow1]->Data)->CellText > ((TCellText *)((TRCellsVector *)Item2)->Owner->Cells[Form1->SortColumn][HRow2]->Data)->CellText)
    {
      Result = -1;
    }
    else
    {
      Result = 0;
    }
  }

  return Result;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1MarkRow(TRCustomGrid *Sender,
      TRCellsVector *CellsVector, bool MarkValue, bool &CanMark)
{
  if (CellsVector->Data)
  {
    if (((TRowData *)CellsVector->Data)->RowIndex == 3)
    {
      if(ShowMessageBox("        !\n\n     ?","", MB_YESNO + MB_ICONWARNING + MB_APPLMODAL) == IDNO)
      {
        CanMark = false;
      }
    }
  }  
}
//---------------------------------------------------------------------------
int __fastcall TForm1::ShowMessageBox(const AnsiString Text, const AnsiString Caption, int Flags)
{
  MessageBeep(MB_OK);
  return Application->MessageBox(Text.c_str(), Caption.c_str(), Flags);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RGrid1FocusCell(TRCustomGrid *Sender, TRCell *Cell,
      int ACol, int ARow, bool &CanFocus)
{
  UpdateSatusBar(ACol, ARow);      
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateSatusBar(int ACol, int ARow)
{
  StatusBar1->Panels->Items[0]->Text = "    " + IntToStr(ACol - RGrid1->FixedCols + 1) + " : " + IntToStr(ARow - RGrid1->FixedRows + 1);
}
//---------------------------------------------------------------------------

